<template>
  <div class="flex flex-col items-center">
    <div class="text-5xl">
      <span @click="current = 'hour'" :class="{ 'text-gray-400': current != 'hour' }">{{
        hour.toString().padStart(2, "0")
      }}</span>
      <span class="mx-1">:</span>
      <span @click="current = 'minute'" :class="{ 'text-gray-400': current != 'minute' }">{{
        minute.toString().padStart(2, "0")
      }}</span>
    </div>
    <div class="mt-4 mx-4">
      <div class="stacking">
        <circle-select
          v-if="current == 'hour'"
          class="w-64 h-64 bg-gray-200"
          :from="1"
          :to="12"
          :shift="1"
          @input="$emit('hour-input', $event)"
          :value="hour"
          @selected="current = 'minute'"
        ></circle-select>
        <circle-select
          v-if="current == 'hour'"
          class="bg-gray-200 text-sm self-center justify-self-center text-gray-700"
          style="width: 11rem; height: 11rem"
          :from="13"
          :to="24"
          :shift="1"
          @input="$emit('hour-input', $event)"
          :value="hour"
          @selected="current = 'minute'"
        ></circle-select>
        <circle-select
          v-else
          class="bg-gray-200 self-center justify-self-center h-64 w-64"
          :from="0"
          :to="59"
          :every="5"
          @input="$emit('minute-input', $event)"
          :value="minute"
        ></circle-select>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { ref } from "@vue/reactivity";
import CircleSelect from "./CircleSelect.vue";

export default {
  components: { CircleSelect },
  props: {
    hour: {
      type: Number,
      required: true
    },
    minute: {
      type: Number,
      required: true
    }
  },
  emits: ["hour-input", "minute-input"],
  setup(props, context) {
    return {
      current: ref("hour")
    };
  }
};
</script>

<style></style>
